package com.javahonk;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.AbstractApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class JavaHonkMainApp {

    private static final Logger logger = LogManager.getLogger(JavaHonkMainApp.class.getName());

    private static String[] configLocation = {"server-context.xml"};

    public static void main(String[] args) {

        logger.info("Starting JavaHonkMainApp...");

        setUncaughtException();

        ApplicationContext context = getApplicationContext();

        registerShutdownHook(context);
    }

    private static void setUncaughtException() {
        Thread.currentThread().setUncaughtExceptionHandler((t, e) -> logger.error("Thread {} threw uncaught exception ", t.getName(), e));
    }

    protected static ApplicationContext getApplicationContext() {
        return new ClassPathXmlApplicationContext(configLocation);
    }

    private static void registerShutdownHook(ApplicationContext context) {
        Runtime.getRuntime().addShutdownHook(new Thread(() -> {
            logger.info("JavaHonkMainApp Exiting.");
            ((AbstractApplicationContext) context).close();
        }));
    }
}
