package com.javahonk.adapter;

import java.io.IOException;
import java.util.List;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.io.IOUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import com.javahonk.proto.JavaHonkDateRangeRequestProto;
import com.javahonk.proto.JavaHonkDateRangeRequestProto.CompositeJavaHonkDateRangeRequestInfo;
import com.javahonk.proto.JavaHonkDateRangeRequestProto.JavaHonkDateRangeRequestInfo;

public class JavaHonkProcessor implements ServerMessageProcessor {

    private static final Logger logger = LogManager.getLogger(JavaHonkProcessor.class.getName());

    public void handleRequest(HttpServletRequest request, HttpServletResponse response) throws IOException {

        byte[] message = IOUtils.toByteArray(request.getInputStream());

        List<JavaHonkDateRangeRequestInfo> compositeSwapResetInfoList = CompositeJavaHonkDateRangeRequestInfo
				.parseFrom(message).getJavaHonkDateRangeRequestInfoList();

		for (JavaHonkDateRangeRequestInfo javaHonkDateRangeRequestInfo : compositeSwapResetInfoList) {
			System.out.println(javaHonkDateRangeRequestInfo.getEndDate());
		}

        logger.info("Successfully parsed message {}", compositeSwapResetInfoList.toString());

        ServletOutputStream outputStream = response.getOutputStream();
        
        JavaHonkDateRangeRequestProto.CompositeJavaHonkDateRangeRequestInfo.Builder compositeJavaHonkDateRangeRequestInfo 
		= JavaHonkDateRangeRequestProto.CompositeJavaHonkDateRangeRequestInfo.newBuilder();
	
		JavaHonkDateRangeRequestInfo.Builder javaHonkDateRangeRequestInfo = JavaHonkDateRangeRequestInfo.newBuilder();
		javaHonkDateRangeRequestInfo.setStartDate("20160628");
		javaHonkDateRangeRequestInfo.setEndDate("20160630");
				
		compositeJavaHonkDateRangeRequestInfo.addJavaHonkDateRangeRequestInfo(javaHonkDateRangeRequestInfo);
		compositeJavaHonkDateRangeRequestInfo.addJavaHonkDateRangeRequestInfo(javaHonkDateRangeRequestInfo);
	
		outputStream.write(compositeJavaHonkDateRangeRequestInfo.build().toByteArray());
    }    

}
