package com.javahonk.test;

import java.io.IOException;
import java.net.MalformedURLException;
import java.util.List;

import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

import org.apache.commons.io.IOUtils;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.ByteArrayEntity;
import org.apache.http.impl.client.HttpClientBuilder;

import com.javahonk.proto.JavaHonkDateRangeRequestProto;
import com.javahonk.proto.JavaHonkDateRangeRequestProto.CompositeJavaHonkDateRangeRequestInfo;
import com.javahonk.proto.JavaHonkDateRangeRequestProto.JavaHonkDateRangeRequestInfo;

public class HTTPPostSendTestData {

	public static void main(String[] args) {
		postHttpAsString("http://localhost:8080/app/javahonk/test", buildData());		
	}

	private static void postHttpAsString(String url, byte[] message) {

		try {
			HttpClient httpClient = HttpClientBuilder.create().build();
			HttpPost postRequest = new HttpPost(url);

			ByteArrayEntity entity = new ByteArrayEntity(message);
			entity.setContentType(MediaType.APPLICATION_OCTET_STREAM);
			postRequest.setEntity(entity);

			HttpResponse response = httpClient.execute(postRequest);

			if (response.getStatusLine().getStatusCode() != Response.Status.OK.getStatusCode()) {
				throw new RuntimeException("Failed : HTTP error code : " + response.getStatusLine().getStatusCode());
			}
			
			byte[] value = IOUtils.toByteArray(response.getEntity().getContent());

	        List<JavaHonkDateRangeRequestInfo> javahonkTestInfo = CompositeJavaHonkDateRangeRequestInfo
					.parseFrom(value).getJavaHonkDateRangeRequestInfoList();

			for (JavaHonkDateRangeRequestInfo javaHonkDateRangeRequestInfo : javahonkTestInfo) {
				System.out.println(javaHonkDateRangeRequestInfo);				
			}

		} catch (MalformedURLException e) {

			e.printStackTrace();

		} catch (IOException e) {

			e.printStackTrace();

		}
	}
	
	private static byte[] buildData(){
		
		JavaHonkDateRangeRequestProto.CompositeJavaHonkDateRangeRequestInfo.Builder compositeJavaHonkDateRangeRequestInfo 
		= JavaHonkDateRangeRequestProto.CompositeJavaHonkDateRangeRequestInfo.newBuilder();
	
		JavaHonkDateRangeRequestInfo.Builder javaHonkDateRangeRequestInfo = JavaHonkDateRangeRequestInfo.newBuilder();
		javaHonkDateRangeRequestInfo.setStartDate("20160628");
		javaHonkDateRangeRequestInfo.setEndDate("20160630");
				
		compositeJavaHonkDateRangeRequestInfo.addJavaHonkDateRangeRequestInfo(javaHonkDateRangeRequestInfo);
		compositeJavaHonkDateRangeRequestInfo.addJavaHonkDateRangeRequestInfo(javaHonkDateRangeRequestInfo);
	
		return compositeJavaHonkDateRangeRequestInfo.build().toByteArray();
	}

}
